/* postprocessor.c generated by valac 0.56.17, the Vala compiler
 * generated from postprocessor.vala, do not modify */

/* SPDX-License-Identifier: GPL-3.0-or-later*/
/*
 * Copyright (C) 2022 Alexander Vogt
 * Author: Alexander Vogt <a.vogt@fulguritus.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_POSTPROCESSOR (postprocessor_get_type ())
#define POSTPROCESSOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POSTPROCESSOR, Postprocessor))
#define POSTPROCESSOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_POSTPROCESSOR, PostprocessorClass))
#define IS_POSTPROCESSOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POSTPROCESSOR))
#define IS_POSTPROCESSOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_POSTPROCESSOR))
#define POSTPROCESSOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_POSTPROCESSOR, PostprocessorClass))

typedef struct _Postprocessor Postprocessor;
typedef struct _PostprocessorClass PostprocessorClass;
typedef struct _PostprocessorPrivate PostprocessorPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecPostprocessor ParamSpecPostprocessor;

struct _Postprocessor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	PostprocessorPrivate * priv;
};

struct _PostprocessorClass {
	GTypeClass parent_class;
	void (*finalize) (Postprocessor *self);
};

struct _ParamSpecPostprocessor {
	GParamSpec parent_instance;
};

static gpointer postprocessor_parent_class = NULL;

VALA_EXTERN gpointer postprocessor_ref (gpointer instance);
VALA_EXTERN void postprocessor_unref (gpointer instance);
VALA_EXTERN GParamSpec* param_spec_postprocessor (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
VALA_EXTERN void value_set_postprocessor (GValue* value,
                              gpointer v_object);
VALA_EXTERN void value_take_postprocessor (GValue* value,
                               gpointer v_object);
VALA_EXTERN gpointer value_get_postprocessor (const GValue* value);
VALA_EXTERN GType postprocessor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Postprocessor, postprocessor_unref)
VALA_EXTERN Postprocessor* postprocessor_new (void);
VALA_EXTERN Postprocessor* postprocessor_construct (GType object_type);
VALA_EXTERN gint postprocessor_process (Postprocessor* self,
                            const gchar* script,
                            const gchar* mime_type,
                            gboolean keep_original,
                            const gchar* source_file,
                            const gchar* arguments,
                            GError** error);
static void postprocessor_finalize (Postprocessor * obj);
static GType postprocessor_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

Postprocessor*
postprocessor_construct (GType object_type)
{
	Postprocessor* self = NULL;
#line 15 "../src/postprocessor.vala"
	self = (Postprocessor*) g_type_create_instance (object_type);
#line 15 "../src/postprocessor.vala"
	return self;
#line 114 "postprocessor.c"
}

Postprocessor*
postprocessor_new (void)
{
#line 15 "../src/postprocessor.vala"
	return postprocessor_construct (TYPE_POSTPROCESSOR);
#line 122 "postprocessor.c"
}

gint
postprocessor_process (Postprocessor* self,
                       const gchar* script,
                       const gchar* mime_type,
                       gboolean keep_original,
                       const gchar* source_file,
                       const gchar* arguments,
                       GError** error)
{
	const gchar* _tmp0_ = NULL;
	gchar** spawn_args = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gint spawn_args_length1;
	gint _spawn_args_size_;
	gchar** spawn_env = NULL;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint spawn_env_length1;
	gint _spawn_env_size_;
	gchar* process_stdout = NULL;
	gchar* process_stderr = NULL;
	gint process_status = 0;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	GError* _inner_error0_ = NULL;
	gint result;
#line 19 "../src/postprocessor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 19 "../src/postprocessor.vala"
	g_return_val_if_fail (script != NULL, 0);
#line 19 "../src/postprocessor.vala"
	g_return_val_if_fail (mime_type != NULL, 0);
#line 19 "../src/postprocessor.vala"
	g_return_val_if_fail (source_file != NULL, 0);
#line 19 "../src/postprocessor.vala"
	g_return_val_if_fail (arguments != NULL, 0);
#line 21 "../src/postprocessor.vala"
	if (keep_original) {
#line 21 "../src/postprocessor.vala"
		_tmp0_ = "true";
#line 171 "postprocessor.c"
	} else {
#line 21 "../src/postprocessor.vala"
		_tmp0_ = "false";
#line 175 "postprocessor.c"
	}
#line 21 "../src/postprocessor.vala"
	_tmp1_ = g_strdup (script);
#line 21 "../src/postprocessor.vala"
	_tmp2_ = g_strdup (mime_type);
#line 21 "../src/postprocessor.vala"
	_tmp3_ = g_strdup (_tmp0_);
#line 21 "../src/postprocessor.vala"
	_tmp4_ = g_strdup (source_file);
#line 21 "../src/postprocessor.vala"
	_tmp5_ = g_strdup (arguments);
#line 21 "../src/postprocessor.vala"
	_tmp6_ = g_new0 (gchar*, 5 + 1);
#line 21 "../src/postprocessor.vala"
	_tmp6_[0] = _tmp1_;
#line 21 "../src/postprocessor.vala"
	_tmp6_[1] = _tmp2_;
#line 21 "../src/postprocessor.vala"
	_tmp6_[2] = _tmp3_;
#line 21 "../src/postprocessor.vala"
	_tmp6_[3] = _tmp4_;
#line 21 "../src/postprocessor.vala"
	_tmp6_[4] = _tmp5_;
#line 21 "../src/postprocessor.vala"
	spawn_args = _tmp6_;
#line 21 "../src/postprocessor.vala"
	spawn_args_length1 = 5;
#line 21 "../src/postprocessor.vala"
	_spawn_args_size_ = spawn_args_length1;
#line 22 "../src/postprocessor.vala"
	_tmp8_ = _tmp7_ = g_get_environ ();
#line 22 "../src/postprocessor.vala"
	spawn_env = _tmp8_;
#line 22 "../src/postprocessor.vala"
	spawn_env_length1 = _vala_array_length (_tmp7_);
#line 22 "../src/postprocessor.vala"
	_spawn_env_size_ = spawn_env_length1;
#line 27 "../src/postprocessor.vala"
	g_print ("Executing script%s\n", script);
#line 28 "../src/postprocessor.vala"
	g_spawn_sync (NULL, spawn_args, spawn_env, G_SPAWN_SEARCH_PATH, NULL, NULL, &_tmp9_, &_tmp10_, &_tmp11_, &_inner_error0_);
#line 28 "../src/postprocessor.vala"
	_g_free0 (process_stdout);
#line 28 "../src/postprocessor.vala"
	process_stdout = _tmp9_;
#line 28 "../src/postprocessor.vala"
	_g_free0 (process_stderr);
#line 28 "../src/postprocessor.vala"
	process_stderr = _tmp10_;
#line 28 "../src/postprocessor.vala"
	process_status = _tmp11_;
#line 28 "../src/postprocessor.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 229 "postprocessor.c"
		gint _tmp12_ = -1;
#line 28 "../src/postprocessor.vala"
		g_propagate_error (error, _inner_error0_);
#line 28 "../src/postprocessor.vala"
		_g_free0 (process_stderr);
#line 28 "../src/postprocessor.vala"
		_g_free0 (process_stdout);
#line 28 "../src/postprocessor.vala"
		spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 28 "../src/postprocessor.vala"
		spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 28 "../src/postprocessor.vala"
		return _tmp12_;
#line 243 "postprocessor.c"
	}
#line 36 "../src/postprocessor.vala"
	g_debug ("postprocessor.vala:36: status: %d\n", process_status);
#line 37 "../src/postprocessor.vala"
	g_debug ("postprocessor.vala:37: STDOUT: \n");
#line 38 "../src/postprocessor.vala"
	g_debug ("postprocessor.vala:38: process_stdout");
#line 39 "../src/postprocessor.vala"
	g_debug ("postprocessor.vala:39: STDERR: \n");
#line 40 "../src/postprocessor.vala"
	g_debug ("postprocessor.vala:40: process_stderr");
#line 42 "../src/postprocessor.vala"
	result = process_status;
#line 42 "../src/postprocessor.vala"
	_g_free0 (process_stderr);
#line 42 "../src/postprocessor.vala"
	_g_free0 (process_stdout);
#line 42 "../src/postprocessor.vala"
	spawn_env = (_vala_array_free (spawn_env, spawn_env_length1, (GDestroyNotify) g_free), NULL);
#line 42 "../src/postprocessor.vala"
	spawn_args = (_vala_array_free (spawn_args, spawn_args_length1, (GDestroyNotify) g_free), NULL);
#line 42 "../src/postprocessor.vala"
	return result;
#line 267 "postprocessor.c"
}

static void
value_postprocessor_init (GValue* value)
{
#line 13 "../src/postprocessor.vala"
	value->data[0].v_pointer = NULL;
#line 275 "postprocessor.c"
}

static void
value_postprocessor_free_value (GValue* value)
{
#line 13 "../src/postprocessor.vala"
	if (value->data[0].v_pointer) {
#line 13 "../src/postprocessor.vala"
		postprocessor_unref (value->data[0].v_pointer);
#line 285 "postprocessor.c"
	}
}

static void
value_postprocessor_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 13 "../src/postprocessor.vala"
	if (src_value->data[0].v_pointer) {
#line 13 "../src/postprocessor.vala"
		dest_value->data[0].v_pointer = postprocessor_ref (src_value->data[0].v_pointer);
#line 297 "postprocessor.c"
	} else {
#line 13 "../src/postprocessor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 301 "postprocessor.c"
	}
}

static gpointer
value_postprocessor_peek_pointer (const GValue* value)
{
#line 13 "../src/postprocessor.vala"
	return value->data[0].v_pointer;
#line 310 "postprocessor.c"
}

static gchar*
value_postprocessor_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 13 "../src/postprocessor.vala"
	if (collect_values[0].v_pointer) {
#line 321 "postprocessor.c"
		Postprocessor * object;
		object = collect_values[0].v_pointer;
#line 13 "../src/postprocessor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 13 "../src/postprocessor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 328 "postprocessor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 13 "../src/postprocessor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 332 "postprocessor.c"
		}
#line 13 "../src/postprocessor.vala"
		value->data[0].v_pointer = postprocessor_ref (object);
#line 336 "postprocessor.c"
	} else {
#line 13 "../src/postprocessor.vala"
		value->data[0].v_pointer = NULL;
#line 340 "postprocessor.c"
	}
#line 13 "../src/postprocessor.vala"
	return NULL;
#line 344 "postprocessor.c"
}

static gchar*
value_postprocessor_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	Postprocessor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 13 "../src/postprocessor.vala"
	if (!object_p) {
#line 13 "../src/postprocessor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 359 "postprocessor.c"
	}
#line 13 "../src/postprocessor.vala"
	if (!value->data[0].v_pointer) {
#line 13 "../src/postprocessor.vala"
		*object_p = NULL;
#line 365 "postprocessor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 13 "../src/postprocessor.vala"
		*object_p = value->data[0].v_pointer;
#line 369 "postprocessor.c"
	} else {
#line 13 "../src/postprocessor.vala"
		*object_p = postprocessor_ref (value->data[0].v_pointer);
#line 373 "postprocessor.c"
	}
#line 13 "../src/postprocessor.vala"
	return NULL;
#line 377 "postprocessor.c"
}

GParamSpec*
param_spec_postprocessor (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecPostprocessor* spec;
#line 13 "../src/postprocessor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_POSTPROCESSOR), NULL);
#line 13 "../src/postprocessor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 13 "../src/postprocessor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 13 "../src/postprocessor.vala"
	return G_PARAM_SPEC (spec);
#line 396 "postprocessor.c"
}

gpointer
value_get_postprocessor (const GValue* value)
{
#line 13 "../src/postprocessor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_POSTPROCESSOR), NULL);
#line 13 "../src/postprocessor.vala"
	return value->data[0].v_pointer;
#line 406 "postprocessor.c"
}

void
value_set_postprocessor (GValue* value,
                         gpointer v_object)
{
	Postprocessor * old;
#line 13 "../src/postprocessor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_POSTPROCESSOR));
#line 13 "../src/postprocessor.vala"
	old = value->data[0].v_pointer;
#line 13 "../src/postprocessor.vala"
	if (v_object) {
#line 13 "../src/postprocessor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_POSTPROCESSOR));
#line 13 "../src/postprocessor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 13 "../src/postprocessor.vala"
		value->data[0].v_pointer = v_object;
#line 13 "../src/postprocessor.vala"
		postprocessor_ref (value->data[0].v_pointer);
#line 428 "postprocessor.c"
	} else {
#line 13 "../src/postprocessor.vala"
		value->data[0].v_pointer = NULL;
#line 432 "postprocessor.c"
	}
#line 13 "../src/postprocessor.vala"
	if (old) {
#line 13 "../src/postprocessor.vala"
		postprocessor_unref (old);
#line 438 "postprocessor.c"
	}
}

void
value_take_postprocessor (GValue* value,
                          gpointer v_object)
{
	Postprocessor * old;
#line 13 "../src/postprocessor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_POSTPROCESSOR));
#line 13 "../src/postprocessor.vala"
	old = value->data[0].v_pointer;
#line 13 "../src/postprocessor.vala"
	if (v_object) {
#line 13 "../src/postprocessor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_POSTPROCESSOR));
#line 13 "../src/postprocessor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 13 "../src/postprocessor.vala"
		value->data[0].v_pointer = v_object;
#line 459 "postprocessor.c"
	} else {
#line 13 "../src/postprocessor.vala"
		value->data[0].v_pointer = NULL;
#line 463 "postprocessor.c"
	}
#line 13 "../src/postprocessor.vala"
	if (old) {
#line 13 "../src/postprocessor.vala"
		postprocessor_unref (old);
#line 469 "postprocessor.c"
	}
}

static void
postprocessor_class_init (PostprocessorClass * klass,
                          gpointer klass_data)
{
#line 13 "../src/postprocessor.vala"
	postprocessor_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/postprocessor.vala"
	((PostprocessorClass *) klass)->finalize = postprocessor_finalize;
#line 481 "postprocessor.c"
}

static void
postprocessor_instance_init (Postprocessor * self,
                             gpointer klass)
{
#line 13 "../src/postprocessor.vala"
	self->ref_count = 1;
#line 490 "postprocessor.c"
}

static void
postprocessor_finalize (Postprocessor * obj)
{
	Postprocessor * self;
#line 13 "../src/postprocessor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_POSTPROCESSOR, Postprocessor);
#line 13 "../src/postprocessor.vala"
	g_signal_handlers_destroy (self);
#line 501 "postprocessor.c"
}

static GType
postprocessor_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_postprocessor_init, value_postprocessor_free_value, value_postprocessor_copy_value, value_postprocessor_peek_pointer, "p", value_postprocessor_collect_value, "p", value_postprocessor_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (PostprocessorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) postprocessor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Postprocessor), 0, (GInstanceInitFunc) postprocessor_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType postprocessor_type_id;
	postprocessor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Postprocessor", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return postprocessor_type_id;
}

GType
postprocessor_get_type (void)
{
	static volatile gsize postprocessor_type_id__once = 0;
	if (g_once_init_enter (&postprocessor_type_id__once)) {
		GType postprocessor_type_id;
		postprocessor_type_id = postprocessor_get_type_once ();
		g_once_init_leave (&postprocessor_type_id__once, postprocessor_type_id);
	}
	return postprocessor_type_id__once;
}

gpointer
postprocessor_ref (gpointer instance)
{
	Postprocessor * self;
	self = instance;
#line 13 "../src/postprocessor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 13 "../src/postprocessor.vala"
	return instance;
#line 536 "postprocessor.c"
}

void
postprocessor_unref (gpointer instance)
{
	Postprocessor * self;
	self = instance;
#line 13 "../src/postprocessor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 13 "../src/postprocessor.vala"
		POSTPROCESSOR_GET_CLASS (self)->finalize (self);
#line 13 "../src/postprocessor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 550 "postprocessor.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

